<?php

require 'classes/Quest.php';
require 'classes/AddReward.php';

class QuestController{

    protected function getMysql($account_id)
    {
        $mysql_conf = getMysqlConfig(crc32($account_id));
        $conn = new phpcommon\Mysql(array(
            'host' => $mysql_conf['host'],
            'port' => $mysql_conf['port'],
            'user' => $mysql_conf['user'],
            'passwd' => $mysql_conf['passwd'],
            'dbname' => 'gamedb2001_' . $mysql_conf['instance_id']
        ));
        return $conn;
    }

    protected function getQuest($quest_id)
    {
        $g_conf_quest_cluster = require('../res/task@task.php');
        $quest_conf = getQuestConfig($g_conf_quest_cluster, $quest_id);
        $q = array(
            'id' => $quest_conf['id'],
            'type' => $quest_conf['type'],
            'condition' => $quest_conf['condition'],
            'value' => $quest_conf['value'],
            'active_value' => $quest_conf['active_value'],
            'reward' => $quest_conf['reward'],
        );
        return $q;
    }

    protected function getParameter($para_id)
    {
        $parameter_meta_cluster = require('../res/parameter@parameter.php');
        $parameter_meta = getParameterConfig($parameter_meta_cluster, $para_id);
        $p = array(
            'id' => $parameter_meta['id'],
            'name' => $parameter_meta['param_name'],
            'value' => $parameter_meta['param_value'],
        );
        return $p;
    }

    protected function getTaskReward($taskReward_id)
    {
        $g_conf_taskReward_cluster = require('../res/taskReward@taskReward.php');
        $taskReward_conf = getTaskRewardConfig($g_conf_taskReward_cluster, $taskReward_id);
        $t = array(
            'id' => $taskReward_conf['id'],
            'type' => $taskReward_conf['type'],
            'value' => $taskReward_conf['value'],
            'reward' => $taskReward_conf['reward']
        );
        return $t;
    }

    protected function getExplode($string)
    {
        $delim = "|";
        $drop_multiply = explode($delim, $string);
        $delim1 = ":";
        $arr = array();
        for ($i = 0; $i < count($drop_multiply); $i++) {
            $mul = explode($delim1, $drop_multiply[$i]);
            array_push($arr, $mul);
        }
        return $arr;
    }

    protected function getDrop($drop_id)
    {
        $g_conf_drop_cluster = require('../res/drop@drop.php');
        $drop_conf = getDropConfig($g_conf_drop_cluster, $drop_id);
        $d = array(
            'drop_id' => $drop_conf['drop_id'],
            'item_id' => $drop_conf['item_id'],
            'num' => $drop_conf['num'],
            'weight' => $drop_conf['weight'],
            'type' => $drop_conf['type']
        );
        return $d;
    }

    protected function insertActive($account_id, $active_id, $task_num)
    {
        $conn = $this->getMysql($account_id);
        for ($i = $active_id; $i < $active_id + $task_num; $i++) {
            $ret = $conn->execScript('INSERT INTO quest(accountid, quest_id, quest_type, quest_state, create_time, modify_time) ' .
                                     ' VALUES(:accountid, :quest_id, :quest_type, :quest_state, :create_time, :modify_time) ' .
                                     ' ON DUPLICATE KEY UPDATE accountid=:accountid, quest_id=:quest_id, quest_type=:quest_type, quest_state=:quest_state, modify_time=:modify_time;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':quest_id' => $i,
                                         ':quest_type' => 0,
                                         ':quest_state'=> 0,
                                         ':create_time' => time(),
                                         ':modify_time' => time()
                                     ));
            if (!$ret) {
                die();
            }
        }
    }

    public function updateActive($account_id, $active_num, $active_sum)
    {
        $conn = $this->getMysql($account_id);
        for ($i = 73001; $i < 73006; $i++) {
            $quest_id = $i;
            $row = $conn->execQueryOne('SELECT * FROM quest WHERE accountid=:accountid AND quest_id=:quest_id;',
                                       array(
                                           ':accountid' => $account_id,
                                           ':quest_id' => $quest_id
                                       ));
            $t = $this->getTaskReward($quest_id);
            if ($row['quest_state'] != 0 || $active_num < $t['value']) {
                continue;
            }
            $ret = $conn->execScript('UPDATE quest SET quest_state=:quest_state, modify_time=:modify_time ' .
                                     ' WHERE accountid=:accountid AND quest_id =:quest_id;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':quest_id' => $quest_id,
                                         ':quest_state' => 1,
                                         ':modify_time' => time()
                                     ));
            if (!$ret) {
                die();
            }
        }

        for ($j = 74001; $j < 74004; $j++) {
            $quest_id = $j;
            $row = $conn->execQueryOne('SELECT * FROM quest WHERE accountid=:accountid AND quest_id=:quest_id;',
                                       array(
                                           ':accountid' => $account_id,
                                           ':quest_id' => $quest_id
                                       ));
            $t = $this->getTaskReward($j);
            if ($row['quest_state'] != 0 || $active_sum < $t['value']) {
                continue;
            }
            $ret = $conn->execScript('UPDATE quest SET quest_state=:quest_state, modify_time=:modify_time ' .
                                     ' WHERE accountid=:accountid AND quest_id =:quest_id;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':quest_id' => $quest_id,
                                         ':quest_state' => 1,
                                         ':modify_time' => time()
                                     ));
            if (!$ret) {
                die();
            }
        }
    }

    protected function updateActiveTime($account_id, $quest_id, $flag)
    {
        $conn = $this->getMysql($account_id);
        if ($flag == 2) {
            $ret = $conn->execScript('UPDATE active SET sum_time=:sum_time, active_sum=:active_sum, modify_time=:modify_time ' .
                                     ' WHERE accountid=:accountid;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':sum_time' => time(),
                                         ':active_sum' => 0,
                                         ':modify_time' => time()
                                     ));
            if (!$ret) {
                die();
            }
        } else if ($flag == 1) {
            $ret = $conn->execScript('UPDATE active SET num_time=:num_time, active_num=:active_num, modify_time=:modify_time ' .
                                     ' WHERE accountid=:accountid;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':num_time' => time(),
                                         ':active_num' => 0,
                                         ':modify_time' => time()
                                     ));
            if (!$ret) {
                die();
            }
        }
        $ret = $conn->execScript('UPDATE quest SET quest_state=:quest_state, modify_time=:modify_time ' .
                                 ' WHERE accountid=:accountid AND quest_type=:quest_type AND quest_id<:quest_id;',
                                 array(
                                     ':accountid' => $account_id,
                                     ':quest_type' => 0,
                                     ':quest_id' => $quest_id,
                                     ':quest_state' => 0,
                                     ':modify_time' => time()
                                 ));
        if (!$ret) {
            die();
        }
    }

    public function questInfo()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $conn = $this->getMysql($account_id);
        $quest_list = array();
        $active_list = array();
        $achievement_list = array();
        $active_sum = 0;
        $active_num = 0;
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 1, '没有这个玩家');
            return;
        }
        $row = $conn->execQueryOne('SELECT active_sum, sum_time FROM active WHERE accountid=:accountid;',
                                   array(
                                       ':accountid' => $account_id,
                                   ));
        if ($row) {
            //每周更新活跃度
            if (phpcommon\getMondayseconds(time()) - phpcommon\getMondayseconds($row['sum_time']) > 0) {
                $this->updateActiveTime($account_id, 75000, 2);
            } else {
                $active_sum = $row['active_sum'];
            }
        }
        $row = $conn->execQueryOne('SELECT active_num, num_time FROM active WHERE accountid=:accountid;',
                                   array(
                                       ':accountid' => $account_id,
                                   ));
        if ($row) {
            //每日更新活跃度
            if (phpcommon\getdayseconds(time()) - phpcommon\getdayseconds($row['num_time']) > 0) {
                $this->updateActiveTime($account_id, 74000, 1);
            } else {
                $active_num = $row['active_num'];
            }
        }
        $rowCount = $conn->execQueryRowCount('SELECT * FROM quest WHERE accountid=:accountid;',
                                             array(
                                                 ':accountid' => $account_id,
                                             ));
        if ($rowCount != 0) {
            $rows = $conn->execQuery('SELECT * FROM quest WHERE accountid=:accountid AND quest_type=:quest_type;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':quest_type' => 1
                                     ));
            if ($rows) {
                foreach ($rows as $row) {
                    array_push($quest_list, array(
                        'type' => $row['quest_type'],
                        'quest_id' => $row['quest_id'],
                        'quest_num' => $row['quest_num'],
                        'quest_state' => $row['quest_state']
                    ));
                }
            }
            $rows = $conn->execQuery('SELECT * FROM quest WHERE accountid=:accountid AND quest_type=:quest_type;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':quest_type' => 2
                                     ));
            if ($rows) {
                foreach ($rows as $row) {
                    array_push($achievement_list, array(
                        'type' => $row['quest_type'],
                        'achievement_id' => $row['quest_id'],
                        'achievement_num' => $row['quest_num'],
                        'achievement_state' => $row['quest_state']
                    ));
                }
            }
            $rows = $conn->execQuery('SELECT * FROM quest WHERE accountid=:accountid AND quest_type=:quest_type;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':quest_type' => 0
                                     ));
            if ($rows) {
                foreach ($rows as $row) {
                    array_push($active_list, array(
                        'type' => $row['quest_type'],
                        'active_id' => $row['quest_id'],
                        'active_state' => $row['quest_state']
                    ));
                }
            }
        }
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
            'active_num' => $active_num,
            'active_sum' => $active_sum,
            'active_list' => $active_list,
            'quest_list' => $quest_list,
            'achievement_list' => $achievement_list
        ));
    }

    public function doubleQuestReward()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $quest_id = $_REQUEST['quest_id'];
        $quest_type = $_REQUEST['type'];
        $p = $this->getParameter(REWARD_TIMES);
        $times = (3 - 1) * 2;
        //发奖励
        if ($quest_type == 0) {
            $t = $this->getTaskReward($quest_id);
            if (!$t) {
                phpcommon\sendError(ERR_USER_BASE + 2, '没有这个任务');
                return;
            }
            $d = $this->getDrop($t['reward']);
            if (!$d) {
                phpcommon\sendError(ERR_USER_BASE + 3, '没有这个奖励');
                return;
            }
            $weight_sum = 0;
            $weight_array = $this->getExplode($d['weight']);
            for ($i = 0; $i < count($weight_array); $i++) {
                $weight_sum += $weight_array[$i][0];
            }

            $random = Rand(0, $weight_sum);
            $weight = 0;
            for ($i = 0; $i < count($weight_array); $i++) {
                $weight += $weight_array[$i][0];
                if ($weight > $random) {
                    $key = $i;
                    break;
                }
            }
            $item_id_array = $this->getExplode($d['item_id']);
            $num_array = $this->getExplode($d['num']);
            $item_id = $item_id_array[$key][0];
            $item_num = $num_array[$key][0] * $times;
            $addreward = new classes\AddReward();
            $addreward->addReward($item_id, $item_num, $account_id);
        } else {
            $q = $this->getQuest($quest_id);
            if (!$q) {
                phpcommon\sendError(ERR_USER_BASE + 2, '没有这个任务');
                return;
            }
            $array = $this->getExplode($q['reward']);
            $reward_id = $array[0][0];
            $reward_num = $array[0][1] * $times;
            $addreward = new classes\AddReward();
            $addreward->addReward($reward_id, $reward_num, $account_id);
        }
        $addreward = new classes\AddReward();
        $coin_num = $addreward->getCoinNum($account_id);
        $diamond_num = $addreward->getDiamondNum($account_id);
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
            'coin_nums' => $coin_num,
            'diamond_nums' => $diamond_num,
        ));
    }

    public function submitQuest()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $quest_id = $_REQUEST['quest_id'];
        $quest_type = $_REQUEST['type'];
        $this->submitReward($quest_id, $quest_type, $account_id, 1);

    }

    public function submitdoubleQuest()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $quest_id = $_REQUEST['quest_id'];
        $quest_type = $_REQUEST['type'];
        $this->submitReward($quest_id, $quest_type, $account_id, 2);

    }

    protected function submitReward($quest_id, $quest_type, $account_id, $isdouble)
    {
        $conn = $this->getMysql($account_id);
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 1, '没有这个玩家');
            return;
        }
        $row = $conn->execQueryOne('SELECT * FROM quest WHERE accountid=:accountid AND quest_id=:quest_id AND quest_type=:quest_type;',
                                   array(
                                       ':accountid' => $account_id,
                                       ':quest_id' => $quest_id,
                                       ':quest_type' => $quest_type
                                   ));
        if (!$row) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个任务');
            return;
        }
        $item_list = array();
        if ($row['quest_state'] == 1) {
            $ret = $conn->execScript('UPDATE quest SET quest_state=:quest_state, modify_time=:modify_time ' .
                                     ' WHERE accountid=:accountid AND quest_id =:quest_id AND quest_type=:quest_type;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':quest_id' => $quest_id,
                                         ':quest_type' => $quest_type,
                                         ':quest_state' => 2,
                                         ':modify_time' => time()
                                     ));
            if (!$ret) {
                die();
                return;
            }

            //发奖励
            if ($quest_type == 0) {
                $t = $this->getTaskReward($quest_id);
                if (!$t) {
                    phpcommon\sendError(ERR_USER_BASE + 2, '没有这个任务');
                    return;
                }
                $d = $this->getDrop($t['reward']);
                if (!$d) {
                    phpcommon\sendError(ERR_USER_BASE + 3, '没有这个奖励');
                    return;
                }
                $weight_sum = 0;
                $weight_array = $this->getExplode($d['weight']);
                for ($i = 0; $i < count($weight_array); $i++) {
                    $weight_sum += $weight_array[$i][0];
                }

                $random = Rand(0, $weight_sum);
                $weight = 0;
                for ($i = 0; $i < count($weight_array); $i++) {
                    $weight += $weight_array[$i][0];
                    if ($weight > $random) {
                        $key = $i;
                        break;
                    }
                }
                $item_id_array = $this->getExplode($d['item_id']);
                $num_array = $this->getExplode($d['num']);
                $item_id = $item_id_array[$key][0];
                $item_num = $num_array[$key][0];
                if ($isdouble == 2) {
                    $item_num = $item_num * 2;
                }
                array_push($item_list, array(
                    'item_id' => $item_id,
                    'item_num' => $item_num,
                ));
                $addreward = new classes\AddReward();
                $addreward->addReward($item_id, $item_num, $account_id);
            } else {
                $q = $this->getQuest($quest_id);
                if (!$q) {
                    phpcommon\sendError(ERR_USER_BASE + 2, '没有这个任务');
                    return;
                }
                $array = $this->getExplode($q['reward']);
                $reward_id = $array[0][0];
                $reward_num = $array[0][1];
                if ($isdouble == 2) {
                    $reward_num = $reward_num * 2;
                }
                array_push($item_list, array(
                    'item_id' => $reward_id,
                    'item_num' => $reward_num,
                ));
                $addreward = new classes\AddReward();
                $addreward->addReward($reward_id, $reward_num, $account_id);
            }
            if ($row['quest_type'] == 1) {
                $active = $conn->execQueryOne('SELECT active_num, active_sum FROM active WHERE accountid=:accountid;',
                                              array(
                                                  ':accountid' => $account_id
                                              ));
                //增加活跃度
                if (!$active) {
                    $this->insertActive($account_id, 73001, 5);
                    $this->insertActive($account_id, 74001, 3);
                    $ret = $conn->execScript('INSERT INTO active(accountid, active_num, num_time, active_sum, sum_time, create_time, modify_time) ' .
                                             ' VALUES(:accountid, :active_num, :num_time, :active_sum, :sum_time, :create_time, :modify_time) ' .
                                             ' ON DUPLICATE KEY UPDATE accountid=:accountid, active_num=:active_num, num_time=:num_time, active_sum=:active_sum, sum_time=:sum_time, modify_time=:modify_time;',
                                             array(
                                                 ':accountid' => $account_id,
                                                 ':active_num' => $q['active_value'],
                                                 ':num_time' => time(),
                                                 ':active_sum' => $q['active_value'],
                                                 ':sum_time' => time(),
                                                 ':create_time' => time(),
                                                 ':modify_time' => time()
                                             ));
                    if (!$ret) {
                        die();
                        return;
                    }
                    $this->updateActive($account_id, $q['active_value'], $q['active_value']);
                } else {
                    $active['active_num'] = $q['active_value'] + $active['active_num'];
                    $active['active_sum'] = $q['active_value'] + $active['active_sum'];
                    $ret = $conn->execScript('UPDATE active SET active_num=:active_num, active_sum=:active_sum, modify_time=:modify_time ' .
                                             ' WHERE accountid=:accountid;',
                                             array(
                                                 ':accountid' => $account_id,
                                                 ':active_num' => $active['active_num'],
                                                 ':active_sum' => $active['active_sum'],
                                                 ':modify_time' => time()
                                             ));
                    if (!$ret) {
                        die();
                        return;
                    }
                    $this->updateActive($account_id, $active['active_num'], $active['active_sum']);
                }
            }
        }
        $addreward = new classes\AddReward();
        $coin_num = $addreward->getCoinNum($account_id);
        $diamond_num = $addreward->getDiamondNum($account_id);
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
            'item_list' => $item_list,
            'coin_nums' => $coin_num,
            'diamond_nums' => $diamond_num
        ));
    }

}
?>
