<?php
require 'classes/AddReward.php';
class SkinController{

    protected function getMysql($account_id)
    {
        $mysql_conf = getMysqlConfig(crc32($account_id));
        $conn = new phpcommon\Mysql(array(
            'host' => $mysql_conf['host'],
            'port' => $mysql_conf['port'],
            'user' => $mysql_conf['user'],
            'passwd' => $mysql_conf['passwd'],
            'dbname' => 'gamedb2001_' . $mysql_conf['instance_id']
        ));
        return $conn;
    }

    protected function getSkin($skin_id)
    {
        $g_conf_skin_cluster = require('../res/dress@dress.php');
        $skin_conf = getSkinConfig($g_conf_skin_cluster, $skin_id);
        $s = array(
            'skin_id' => $skin_conf['id'],
            'skin_name' => $skin_conf['name'],
            'skin_skillid' => $skin_conf['skill_id'],
            'skin_compose' => $skin_conf['compose'],
            'skin_experience' => $skin_conf['is_experience'],
            'skin_type' => $skin_conf['type'],
            'duration' => $skin_conf['duration'],
            'debris_id' => $skin_conf['debris'],
            'cost' => $skin_conf['cost'],
            'cost_int' => $skin_conf['cost_int'],
            'max_lv' => $skin_conf['max_lv'],
        );
        return $s;
    }

     protected function getExplode($string)
    {
        $delim = "|";
        $drop_multiply = explode($delim, $string);
        $delim1 = ":";
        $arr = array();
        for ($i = 0; $i < count($drop_multiply); $i++) {
            $mul = explode($delim1, $drop_multiply[$i]);
            array_push($arr, $mul);
        }
        return $arr;
    }

    protected function getParameter($para_id)
    {
        $g_conf_para_cluster = require('../res/parameter@parameter.php');
        $para_conf = getParameterConfig($g_conf_para_cluster, $para_id);
        $p = array(
            'id' => $para_conf['id'],
            'param_name' => $para_conf['param_name'],
            'param_value' => $para_conf['param_value'],
        );
        return $p;
    }

    protected function updateActiveTime($row, $conn)
    {
        $skin_status = 0;
        if ($row['skin_type'] == 1) {
            $skin_status = 2;
        } else if ($row['skin_type'] == 2) {
            $skin_status = 3;
        }
        $ret = $conn->execScript('UPDATE skin SET active_time=0, skin_experience_level=0, skin_experience_type=0, modify_time=:modify_time ' .
                                 ' WHERE accountid=:account_id AND skin_id=:skin_id;',
                                 array(
                                     ':account_id' => $row['accountid'],
                                     ':skin_id' => $row['skin_id'],
                                     ':modify_time' => time()
                                 ));
        if(!$ret){
            die();
            return;
        }
        if ($row['skin_status'] == 0 && $row['skin_experience_type'] == 1) {
            $ret = $conn->execScript('UPDATE skin SET skin_status=:skin_status, modify_time=:modify_time ' .
                                     ' WHERE accountid=:account_id AND skin_id=:skin_id;',
                                     array(
                                         ':account_id' => $row['accountid'],
                                         ':skin_id' => $row['skin_id'],
                                         ':skin_status' => $skin_status,
                                         ':modify_time' => time()
                                     ));
            if(!$ret){
                die();
                return;
            }
            $ret = $conn->execScript('UPDATE skin SET skin_status=0, modify_time=:modify_time ' .
                                     ' WHERE accountid = :account_id AND skin_id = 14001;',
                                     array(
                                         ':account_id' => $row['accountid'],
                                         ':modify_time' => time()
                                     ));
            if(!$ret){
                die();
                return;
            }
        }
    }
    public function skinInfo()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $conn = $this->getMysql($account_id);
        $skin_list = array();
        if(!$conn){
            phpcommon\sendError(ERR_USER_BASE + 1,'没有这个玩家');
            return;
        }
        $g_conf_skin_cluster = require('../res/dress@dress.php');
        $s = $this->getSkin(14001);
        if(!$s){
            phpcommon\sendError(ERR_USER_BASE + 1,'没有这个皮肤');
            return;
        }
        $rowCount = $conn->execQueryRowCount('SELECT * FROM skin WHERE accountid = :account_id;',
                                             array(
                                                 ':account_id' => $account_id
                                             ));
        if ($rowCount == 0) {
            for ($i = 14001; $i <= count($g_conf_skin_cluster) + 14000; $i++) {
                $s = $this->getSkin($i);
                if(!$s){
                    phpcommon\sendError(ERR_USER_BASE + 1,'没有这个皮肤');
                    return;
                }
                if ($i == 14001) {
                    $skin_status = 0;
                } else if ($s['skin_type'] == 2){
                    $skin_status = 3;
                } else {
                    $skin_status = 2;
                }
                $ret = $conn->execScript('INSERT INTO skin(accountid, skin_id, skin_status, fragment_id, fragment_num, active_time, fragment_status, skin_type, skin_level, skin_experience_level, skin_experience_type, create_time, modify_time) ' .
                                         ' VALUES(:account_id, :skin_id, :skin_status, :fragment_id, 0, 0, 0, :skin_type, 1, 0, 0, :create_time, :modify_time) ' .
                                         ' ON DUPLICATE KEY UPDATE accountid=:account_id, skin_id=:skin_id, skin_status=:skin_status, fragment_id=:fragment_id, fragment_num=0, active_time=0, fragment_status=0, skin_type=:skin_type, skin_level=1, skin_experience_level=0, skin_experience_type=0, modify_time=:modify_time;',
                                         array(
                                             ':account_id' => $account_id,
                                             ':skin_id' => $i,
                                             ':skin_status' => $skin_status,
                                             ':fragment_id' => $s['debris_id'],
                                             ':skin_type' => $s['skin_type'],
                                             ':create_time' => time(),
                                             ':modify_time' => time()
                                         ));
                if(!$ret){
                    die();
                    return;
                }
            }
        }
        $time = 0;
        $skin_level = 0;
        $skin_experience_type = 0;
        $skin_status = 0;
        $rows = $conn->execQuery('SELECT * FROM skin WHERE accountid = :account_id;',
                                 array(
                                     ':account_id' => $account_id,
                                 ));

        foreach ($rows as $row) {
            $s = $this->getSkin($row['skin_id']);
            if(time() >= $row['active_time'] && $row['active_time'] != 0){
                $this->updateActiveTime($row, $conn);
            }
        }
        $rowsSkin = $conn->execQuery('SELECT * FROM skin WHERE accountid = :account_id;',
                                     array(
                                         ':account_id' => $account_id,
                                     ));
        $skin_id = 0;
        foreach ($rowsSkin as $rowSkin) {
            $s = $this->getSkin($rowSkin['skin_id']);
            if ($skin_id == $rowSkin['skin_id']) {
                continue;
            }
            $skin_id = $rowSkin['skin_id'];
            if ($rowSkin['active_time'] != 0) {
                $skin_level = $s['max_lv'];
                $skin_experience_type = 2;
            } else {
                $skin_level = $rowSkin['skin_level'];
                $skin_experience_type = 0;
            }
            array_push($skin_list, array(
                'skin_id' => $rowSkin['skin_id'],
                'skin_status' => $rowSkin['skin_status'],
                'fragment_num' => $rowSkin['fragment_num'],
                'active_time' => $rowSkin['active_time'],
                'skin_level' => $skin_level,
                'skin_experience_type' => $skin_experience_type
            ));
        }
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
            'skin_list' => $skin_list
        ));
    }


    public function unlockSkin()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $conn = $this->getMysql($account_id);
        $skin_id = $_REQUEST['skin_id'];
        if(!$conn){
            phpcommon\sendError(ERR_USER_BASE + 1,'没有这个玩家');
            return;
        }
        $s = $this->getSkin($skin_id);
        if(!$s){
            phpcommon\sendError(ERR_USER_BASE + 1,'没有这个皮肤1');
            return;
        }
        $row = $conn->execQueryOne('SELECT * FROM skin WHERE accountid = :account_id AND skin_id = :skin_id;',
                                   array(
                                       ':account_id' => $account_id,
                                       ':skin_id' => $skin_id
                                   ));
        if(!$row){
            phpcommon\sendError(ERR_USER_BASE + 1,'没有这个皮肤');
            return;
        }
        if ($row['skin_type'] != 1) {
            phpcommon\sendError(ERR_USER_BASE + 3,'皮肤无法解锁');
            return;
        }
        $fragment_num = 0;
        $array = $this->getExplode($s['skin_compose']);
        if ($row['fragment_num'] < $array[0][1]) {
            phpcommon\sendError(ERR_USER_BASE + 2,'皮肤碎片数量不足');
            return;
        }
        $fragment_num = $row['fragment_num'] - $array[0][1];

        $skin_status = 1;
        $active_time = 0;
        $skin_experience_type = 0;
        if ($row['skin_status'] == 0) {
            $skin_status = 0;
        }
        if ($row['active_time'] != 0) {
            $active_time = $row['active_time'];
            $skin_experience_type = 2;
        }
        $ret = $conn->execScript('UPDATE skin SET fragment_num=:fragment_num ,skin_status=:skin_status, active_time=:active_time, skin_experience_type=:skin_experience_type, modify_time=:modify_time ' .
                                 ' WHERE accountid = :account_id AND skin_id = :skin_id;',
                                 array(
                                     ':account_id' => $account_id,
                                     ':skin_id' => $skin_id,
                                     ':fragment_num' => $fragment_num,
                                     ':skin_status' => $skin_status,
                                     ':active_time' => $active_time,
                                     ':skin_experience_type' => $skin_experience_type,
                                     ':modify_time' => time()
                                 ));
        if (!$ret) {
            die();
            return;
        }
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
        ));
    }

    public function exchangeSkin()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $usingskin_id = $_REQUEST['usingskin_id'];
        $exchangeskin_id = $_REQUEST['exchangeskin_id'];
        $conn = $this->getMysql($account_id);
        if(!$conn){
            phpcommon\sendError(ERR_USER_BASE + 1, '没有这个玩家');
            return;
        }
        $skin_status = 0;
        $row = $conn->execQueryOne('SELECT * FROM skin WHERE accountid=:accountid AND skin_id=:skin_id;',
                                   array(
                                       ':accountid' => $account_id,
                                       ':skin_id' => $usingskin_id,
                                   ));
        if (!$row) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个皮肤');
            return;
        }
        if ($row['skin_experience_type'] == 0 || $row['skin_experience_type'] == 2) {
            $skin_status = 1;
        } else if ($row['skin_experience_type'] == 1) {
            if ($row['skin_type'] == 1) {
                $skin_status = 2;
            } else if ($row['skin_type'] == 2) {
                $skin_status = 3;
            }
        }
        $using_ret = $conn->execScript('UPDATE skin SET skin_status=:skin_status, modify_time=:modify_time ' .
                                       ' WHERE accountid = :account_id AND skin_id = :skin_id;',
                                       array(
                                           ':account_id' => $account_id,
                                           ':skin_id' => $usingskin_id,
                                           ':skin_status' => $skin_status,
                                           ':modify_time' => time()
                                       ));

        if(!$using_ret){
            die();
            return;
        }
        $exchange_ret = $conn->execScript('UPDATE skin SET skin_status=0, modify_time=:modify_time ' .
                                          ' WHERE accountid = :account_id AND skin_id = :skin_id;',
                                          array(
                                              ':account_id' => $account_id,
                                              ':skin_id' => $exchangeskin_id,
                                              ':modify_time' => time()
                                          ));
        if(!$exchange_ret){
            die();
            return;
        }
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
        ));
    }

    public function freetryskin()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $conn = $this->getMysql($account_id);
        $skin_id = $_REQUEST['skin_id'];
        if(!$conn){
            phpcommon\sendError(ERR_USER_BASE + 1,'没有这个角色');
            return;
        }
        $s = $this->getSkin($skin_id);
        if(!$s){
            phpcommon\sendError(ERR_USER_BASE + 2,'没有这个皮肤');
            return;
        }
        $rowSkin = $conn->execQueryOne('SELECT * FROM skin WHERE accountid=:accountid AND skin_id=:skin_id;',
                                       array(
                                           ':accountid' => $account_id,
                                           ':skin_id' => $skin_id,
                                       ));
        if (!$rowSkin) {
            $ret = $conn->execScript('INSERT INTO skin(accountid, skin_id, skin_status, fragment_id, fragment_num, active_time, fragment_status, skin_type, skin_level, skin_experience_level, skin_experience_type, create_time, modify_time) ' .
                                     ' VALUES(:account_id, :skin_id, :skin_status, :fragment_id, 0, 0, 0, :skin_type, 1, 0, 0, :create_time, :modify_time) ' .
                                     ' ON DUPLICATE KEY UPDATE accountid=:account_id, skin_id=:skin_id, skin_status=:skin_status, fragment_id=:fragment_id, fragment_num=0, active_time=0, fragment_status=0, skin_type=:skin_type, skin_level=1, skin_experience_level=0, skin_experience_type=0, modify_time=:modify_time;',
                                     array(
                                         ':account_id' => $account_id,
                                         ':skin_id' => $skin_id,
                                         ':skin_status' => 2,
                                         ':fragment_id' => $skin_id - 1000,
                                         ':skin_type' => 1,
                                         ':create_time' => time(),
                                         ':modify_time' => time()
                                     ));
            if(!$ret){
                die();
                return;
            }
        }
        $row = $conn->execQueryOne('SELECT * FROM skin WHERE accountid=:accountid AND skin_id=:skin_id;',
                                   array(
                                       ':accountid' => $account_id,
                                       ':skin_id' => $skin_id,
                                   ));
        $time = 0;
        $ex_level = 0;
        $ex_type = 0;
        if ($s['skin_type'] == 2) {
            $time = $s['duration'];
        }
        $ex_level = $s['max_lv'];
        $p = $this->getParameter(SKIN_SKILL_TIME);
        $time = $p['param_value'];
        if ($row['skin_status'] <= 1) {
            $ex_type = 2;
        } else {
            $ex_type = 1;
        }
        $ret = $conn->execScript('UPDATE skin SET active_time=:active_time, skin_experience_level=:skin_experience_level, skin_experience_type=:skin_experience_type, modify_time=:modify_time ' .
                                 ' WHERE accountid = :account_id AND skin_id = :skin_id;',
                                 array(
                                     ':account_id' => $account_id,
                                     ':skin_id' => $skin_id,
                                     ':active_time' => time() + $time,
                                     ':skin_experience_level' => $ex_level,
                                     ':skin_experience_type' => $ex_type,
                                     ':modify_time' => time()
                                 ));
        if(!$ret){
            die();
            return;
        }
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
        ));
    }

    public function updateSkin()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $conn = $this->getMysql($account_id);
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 1, '没有这个角色');
            return;
        }
        $skin_id = $_REQUEST['skin_id'];
        $free = $_REQUEST['free'];
        $row = $conn->execQueryOne('SELECT * FROM skin WHERE accountid=:account_id AND skin_id=:skin_id;',
                                   array(
                                       ':account_id' => $account_id,
                                       ':skin_id' => $skin_id
                                   ));
        if (!$row) {
            phpcommon\sendError(ERR_USER_BASE + 1, '皮肤不存在');
            return;
        }
        $s = $this->getSkin($skin_id);
        if (!$s) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个皮肤');
            return;
        }
        if ($row['skin_level'] >= $s['max_lv']) {
            phpcommon\sendError(ERR_USER_BASE + 3, '皮肤已到满级');
            return;
        }
        $debris_num = $s['cost'] * ceil($row['skin_level'] / 5) + $s['cost_int'];
        if ($free == 1) {
            $debris_num = 0;
        }
        if ($debris_num > $row['fragment_num']) {
            phpcommon\sendError(ERR_USER_BASE + 4, '皮肤碎片数量不足');
            return;
        }
        $ret = $conn->execScript('UPDATE skin SET skin_level=:skin_level, fragment_num=:fragment_num, modify_time=:modify_time ' .
                                 ' WHERE accountid=:account_id AND skin_id=:skin_id;',
                                 array(
                                     ':account_id' => $account_id,
                                     ':skin_id' => $skin_id,
                                     ':skin_level' => $row['skin_level'] + 1,
                                     ':fragment_num' => $row['fragment_num'] - $debris_num,
                                     ':modify_time' => time()
                                 ));
        if (!$ret) {
            die();
            return;
        }
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
        ));
    }

    public function getSkinReward()
    {
        $account_id = $_REQUEST['account_id'];
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }

        $conn = $this->getMysql($account_id);
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个玩家');
            return;
        }
        $skin_id = $_REQUEST['id'];
        $row = $conn->execQueryOne('SELECT fragment_num FROM skin WHERE accountid=:account_id AND skin_id=:skin_id;',
                                   array(
                                       ':account_id' => $account_id,
                                       ':skin_id' => $skin_id
                                   ));
        if (!$row) {
            phpcommon\sendError(ERR_USER_BASE + 1, '皮肤不存在');
            return;
        }
        $ret = $conn->execScript('UPDATE skin SET fragment_num=:fragment_num, modify_time=:modify_time ' .
                                 ' WHERE accountid=:account_id AND skin_id=:skin_id;',
                                 array(
                                     ':account_id' => $account_id,
                                     ':skin_id' => $skin_id,
                                     ':fragment_num' => $row['fragment_num'] + 20,
                                     ':modify_time' => time()
                                 ));
        if (!$ret) {
            die();
            return;
        }
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
        ));
    }

    public function getFreeSkin()
    {
        $account_id = $_REQUEST['account_id'];
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }

        $conn = $this->getMysql($account_id);
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个玩家');
            return;
        }
        $skin_id = $_REQUEST['skin_id'];
        $s = $this->getSkin($skin_id);
        if (!$s['skin_id']) {
            phpcommon\sendError(ERR_USER_BASE + 3, '没有这个皮肤');
            return;
        }
        $item_list = array();
        array_push($item_list, array(
            'item_id' => $skin_id,
            'item_num' => 1,
        ));
        $addreward = new classes\AddReward();
        $item_list = $addreward->addReward($skin_id, 1, $account_id);
        $coin_num = $addreward->getCoinNum($account_id);
        $num = $addreward->getDiamondNum($account_id);
        echo json_encode(array(
            'errcode' => 0,
            'errmsg'=> '',
            'item_list' => $item_list,
            'coin_num' => $coin_num,
            'diamond_nums' => $num,
        ));
    }
}
?>
